"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.removePendingSession = exports.addNewPendingSession = void 0;
const db_1 = require("./db");
function addNewPendingSession(capability) {
    return __awaiter(this, void 0, void 0, function* () {
        (yield db_1.ADTDatabase.PendingSessionsModel).insert(capability);
    });
}
exports.addNewPendingSession = addNewPendingSession;
function removePendingSession(sessionCapabilityId) {
    return __awaiter(this, void 0, void 0, function* () {
        (yield db_1.ADTDatabase.PendingSessionsModel)
            .chain()
            .find({ capability_id: sessionCapabilityId })
            .remove();
    });
}
exports.removePendingSession = removePendingSession;
