"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Cloud_1 = __importDefault(require("../../enums/Cloud"));
class CapabilityManager {
    constructor(capabilities, freeDevice) {
        this.capabilities = capabilities;
        this.freeDevice = freeDevice;
    }
    getCapability() {
        const entries = Object.entries(this.freeDevice.capability);
        entries.map(([key, val]) => {
            this.capabilities.alwaysMatch[`appium:${key}`] = val;
        });
        if (this.freeDevice.cloud.toLowerCase() === Cloud_1.default.PCLOUDY) {
            this.capabilities.alwaysMatch['appium:pCloudy_ApiKey'] = process.env.CLOUD_KEY;
            this.capabilities.alwaysMatch['appium:pCloudy_Username'] = process.env.CLOUD_USERNAME;
        }
        return this.capabilities;
    }
}
exports.default = CapabilityManager;
